"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var __async = (__this, __arguments, generator) => {
  return new Promise((resolve, reject) => {
    var fulfilled = (value) => {
      try {
        step(generator.next(value));
      } catch (e) {
        reject(e);
      }
    };
    var rejected = (value) => {
      try {
        step(generator.throw(value));
      } catch (e) {
        reject(e);
      }
    };
    var step = (x) => x.done ? resolve(x.value) : Promise.resolve(x.value).then(fulfilled, rejected);
    step((generator = generator.apply(__this, __arguments)).next());
  });
};

// src/index.ts
var src_exports = {};
__export(src_exports, {
  present: () => present,
  presentSync: () => presentSync,
  presentableKeys: () => presentableKeys,
  presentableKeysSync: () => presentableKeysSync
});
module.exports = __toCommonJS(src_exports);

// src/present.ts
var import_types = require("@sd-jwt/types");
var import_utils = require("@sd-jwt/utils");
var import_decode = require("@sd-jwt/decode");
var presentableKeys = (rawPayload, disclosures, hasher) => __async(void 0, null, function* () {
  const { disclosureKeymap } = yield (0, import_decode.unpack)(rawPayload, disclosures, hasher);
  return Object.keys(disclosureKeymap).sort();
});
var presentableKeysSync = (rawPayload, disclosures, hasher) => {
  const { disclosureKeymap } = (0, import_decode.unpackSync)(rawPayload, disclosures, hasher);
  return Object.keys(disclosureKeymap).sort();
};
var present = (sdJwt, keys, hasher) => __async(void 0, null, function* () {
  const { jwt, kbJwt } = (0, import_decode.splitSdJwt)(sdJwt);
  const {
    jwt: { payload },
    disclosures
  } = yield (0, import_decode.decodeSdJwt)(sdJwt, hasher);
  const { _sd_alg: alg } = (0, import_decode.getSDAlgAndPayload)(payload);
  const hash = { alg, hasher };
  const hashmap = yield (0, import_decode.createHashMapping)(disclosures, hash);
  const { disclosureKeymap } = yield (0, import_decode.unpack)(payload, disclosures, hasher);
  const presentableKeys2 = Object.keys(disclosureKeymap);
  const missingKeys = keys.filter((k) => !presentableKeys2.includes(k));
  if (missingKeys.length > 0) {
    throw new import_utils.SDJWTException(
      `Invalid sd-jwt: invalid present keys: ${missingKeys.join(", ")}`
    );
  }
  const presentedDisclosures = keys.map((k) => hashmap[disclosureKeymap[k]]);
  return [
    jwt,
    ...presentedDisclosures.map((d) => d.encode()),
    kbJwt != null ? kbJwt : ""
  ].join(import_types.SD_SEPARATOR);
});
var presentSync = (sdJwt, keys, hasher) => {
  const { jwt, kbJwt } = (0, import_decode.splitSdJwt)(sdJwt);
  const {
    jwt: { payload },
    disclosures
  } = (0, import_decode.decodeSdJwtSync)(sdJwt, hasher);
  const { _sd_alg: alg } = (0, import_decode.getSDAlgAndPayload)(payload);
  const hash = { alg, hasher };
  const hashmap = (0, import_decode.createHashMappingSync)(disclosures, hash);
  const { disclosureKeymap } = (0, import_decode.unpackSync)(payload, disclosures, hasher);
  const presentableKeys2 = Object.keys(disclosureKeymap);
  const missingKeys = keys.filter((k) => !presentableKeys2.includes(k));
  if (missingKeys.length > 0) {
    throw new import_utils.SDJWTException(
      `Invalid sd-jwt: invalid present keys: ${missingKeys.join(", ")}`
    );
  }
  const presentedDisclosures = keys.map((k) => hashmap[disclosureKeymap[k]]);
  return [
    jwt,
    ...presentedDisclosures.map((d) => d.encode()),
    kbJwt != null ? kbJwt : ""
  ].join(import_types.SD_SEPARATOR);
};
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  present,
  presentSync,
  presentableKeys,
  presentableKeysSync
});
